<?php

include('global.php');

class Index extends Page
{
  var $FullTitle = 'Seznam serverů';
  var $ShortTitle = 'Seznam serverů';
  
  function ShowServerList()
  {
    $Output = '<h4>Seznam serverů</h4>';
    $Output .= '<table class="WideTable"><tr><th>Název</th><th>Uživatel</th><th>Realmd</th><th>Verze hry</th></tr>';
    $DbResult = $this->Database->query('SELECT `ClientVersion`.`Version`, `Server`.`Name`, `Server`.`NetworkPortRealmd`, `User`.`Name` AS `UserName` FROM `Server` JOIN `User` ON `User`.`Id` = `Server`.`User` JOIN `Database` ON `Database`.`Id` = `Server`.`Database` JOIN `Emulator` ON `Emulator`.`Id` = `Database`.`Emulator` JOIN `ClientVersion` ON `ClientVersion`.`Id` = `Emulator`.`ClientVersion`');
    while($Server = $DbResult->fetch_assoc())
    {
      $Output .= '<tr><td>'.$Server['Name'].'</td><td>'.$Server['UserName'].'</td><td>'.$this->System->Config['Web']['Host'].':'.$Server['NetworkPortRealmd'].'</td><td>'.$Server['Version'].'</td></tr>';
    }
    $Output .= '</table>';
    return($Output);
  }
  
  function ShowServer($Id)
  {
    $Server = new Server($this->Database, $Id);
    $Output = '<h4>Podrobnosti serveru</h4>';
    $Output .= '<table class="WideTable"><tr><th>Položka</th><th>Hodnota</th></tr>';
    $Output .= '<tr><td>Jméno</td><td>'.$Server->Server['Name'].'</td></tr>'.
      '<tr><td>Zpráva dne</td><td>'.$Server->Server['Motd'].'</td></tr>'.
      '<tr><td>Síťový port realmd</td><td>'.($Server->RealmdBaseNetworkPort + $Server->Id).'</td></tr>'.
      '<tr><td>Síťový port mangosd</td><td>'.($Server->WorlddBaseNetworkPort + $Server->Id).'</td></tr>'.
      '<tr><td>Emulátor</td><td>'.$Server->Server['Database']['Emulator']['Name'].'</td></tr>'.
      '<tr><td>Databáze</td><td>'.$Server->Server['Database']['Name'].'</td></tr>';
    $Output .= '</table>';
    $Output .= '<br /><a href="'.$this->System->Config['Web']['Host'].'/mysql/">Správa databáze</a> ';
    $ServerStatus = $Server->GetState();
    if($ServerStatus['RealmdPortState'] == true) $Output .= ' <a href="?Action=ServerStop">Zastavit server</a>  <a href="?Action=ServerRestart">RestartovatServer</a>';
      else $Output .= ' <a href="?Action=ServerStart">Spustit server</a>';
    
    return($Output);
  }
  
  function Show()
  {
    $Output = '';
    if(array_key_exists('Action', $_GET))
    {
      if($_GET['Action'] == 'LoginForm')
      {
        $Form = new Form('UserLogin');
        $Form->OnSubmit = '?Action=Login';
        $Output .= $Form->ShowEditForm();
        $Output .= '<div class="Centred"><a href="?Action=UserRegister">Registrovat se</a> '.
		    '<a href="?Action=PasswordRecovery">Obnova zapomenutého hesla</a></div>';
      } else
      if($_GET['Action'] == 'Login')
      {
        $Form = new Form('UserLogin');
        $Form->OnSubmit = '?Action=Login';
        $Result = $this->System->Modules['User']->Login($_POST['Username'], $_POST['Password']);
        $Output .= $this->SystemMessage('Přihlášení', $Result);
        if($Result <> USER_LOGGED_IN)
        {
          $Form->LoadValuesFromForm();
          $Form->Values['Password'] = '';
          $Output .= $Form->ShowEditForm();
          $Output .= '<div class="Centred"><a href="?Action=UserRegister">Registrovat se</a> '.
	    	    '<a href="?Action=PasswordRecovery">Obnova zapomenutého hesla</a></div>';
        }
      } else 
      if($_GET['Action'] == 'Logout')
      {
        $Output .= $this->SystemMessage('Odhlášení', $this->System->Modules['User']->Logout());
      } else
      if($_GET['Action'] == 'UserOptions')
      { 
        $UserOptions = new Form('UserOptions');
        $UserOptions->LoadValuesFromDatabase($this->System->Modules['User']->User['Id']);
        $UserOptions->OnSubmit = '?Action=UserOptionsSave';
        $Output .= $UserOptions->ShowEditForm();
      } else
      if($_GET['Action'] == 'UserOptionsSave')
      {
        $UserOptions = new Form('UserOptions', array());
        $UserOptions->LoadValuesFromForm();
        $UserOptions->SaveValuesToDatabase($this->System->Modules['User']->User['Id']);
        $Output .= $this->SystemMessage('Nastavení', 'Nastavení uloženo.');
        $this->System->Modules['Log']->NewRecord('User', 'Nastavení uživatele změněno', $UserOptions->Values['Name']);
        $UserOptions->LoadValuesFromDatabase($this->System->Modules['User']->User['Id']);
        $UserOptions->OnSubmit = '?Action=UserOptionsSave';
        $Output .= $UserOptions->ShowEditForm();
      } else
      if($_GET['Action'] == 'UserRegister')
      {
        $Form = new Form('UserRegister');
        $Form->LoadValuesFromForm();
        $Form->OnSubmit = '?Action=UserRegisterSave';
        $Output .= $Form->ShowEditForm();
      } else
      if($_GET['Action'] == 'UserRegisterConfirm')
      {
        $Output .= $this->SystemMessage('Potvrzení registrace', $this->System->Modules['User']->RegisterConfirm($_GET['User'], $_GET['H']));
      } else
      if($_GET['Action'] == 'PasswordRecovery')
      {
        $Form = new Form('PasswordRecovery');
        $Form->OnSubmit = '?Action=PasswordRecovery2';
        $Output .= $Form->ShowEditForm();
      } else
      if($_GET['Action'] == 'PasswordRecovery2')
      {
        $Form = new Form('PasswordRecovery');
        $Form->LoadValuesFromForm();
        $Result = $this->System->Modules['User']->PasswordRecoveryRequest($Form->Values['Name'], $Form->Values['Email']);
        $Output .= $this->SystemMessage('Obnova hesla', $Result);
        if($Result <> USER_PASSWORD_RECOVERY_SUCCESS)
        {
          $Output .= $Form->ShowEditForm();
        }        
      } else
      if($_GET['Action'] == 'PasswordRecoveryConfirm')
      {
        $Output .= $this->SystemMessage('Obnova hesla', $this->System->Modules['User']->PasswordRecoveryConfirm($_GET['User'], $_GET['H'], $_GET['P']));
      } else
      if($_GET['Action'] == 'UserRegisterSave')
      {
        $Form = new Form('UserRegister', array());
        $Form->LoadValuesFromForm();
        $Result = $this->System->Modules['User']->Register($Form->Values['Login'], $Form->Values['Password'], $Form->Values['Password2'], $Form->Values['Email'], $Form->Values['Name'], $Form->Values['PhoneNumber'], $Form->Values['ICQ']);
        $Output .= $this->SystemMessage('Registrace nového účtu', $Result);
        if($Result <> USER_REGISTRATED) 
        {
          $Form->OnSubmit = '?Action=UserRegisterSave';
          $Output .= $Form->ShowEditForm();
        }
      } else
      if($_GET['Action'] == 'MemberOptions')
      {
        $UserOptions = new Form('MemberOptions');
        $DbResult = $this->Database->query('SELECT Member.Id, Member.InternetTariffNextMonth, Member.FamilyMemberCount, Member.BillingPeriodNext, Subject.Name, Subject.AddressStreet, Subject.AddressTown, Subject.AddressPSC, Subject.IC, Subject.DIC FROM Member JOIN Subject ON Subject.Id = Member.Subject WHERE Member.Id='.$this->System->Modules['User']->User['Member']);
        $DbRow = $DbResult->fetch_array();
        foreach($UserOptions->Definition['Items'] as $Index => $Item)
        {
          $UserOptions->Values[$Index] = $DbRow[$Index];
        }
        $UserOptions->OnSubmit = '?Action=MemberOptionsSave';
        $Output .= $UserOptions->ShowEditForm();
      } else
      if($_GET['Action'] == 'MemberOptionsSave')
      {
        $UserOptions = new Form('MemberOptions');
        $UserOptions->LoadValuesFromForm();
        if($UserOptions->Values['FamilyMemberCount'] < 0)
          $UserOptions->Values['FamilyMemberCount'] = 0;
        if($UserOptions->Values['BillingPeriodNext'] < 2)
          $UserOptions->Values['BillingPeriodNext'] = 2;
          
        $DbResult = $this->Database->update('Member', 'Id='.$this->System->Modules['User']->User['Member'], array('InternetTariffNextMonth' => $UserOptions->Values['InternetTariffNextMonth'], 'FamilyMemberCount' => $UserOptions->Values['FamilyMemberCount'], 'BillingPeriodNext' => $UserOptions->Values['BillingPeriodNext']));
        $DbResult = $this->Database->query('SELECT Subject FROM Member WHERE Id='.$this->System->Modules['User']->User['Member']);
        $Member = $DbResult->fetch_assoc();
        $DbResult = $this->Database->update('Subject', 'Id='.$Member['Subject'], array('Name' => $UserOptions->Values['Name'], 'AddressStreet' => $UserOptions->Values['AddressStreet'], 'AddressTown' => $UserOptions->Values['AddressTown'], 'AddressPSC' => $UserOptions->Values['AddressPSC'], 'IC' => $UserOptions->Values['IC'], 'DIC' => $UserOptions->Values['DIC']));
        $Output .= $this->SystemMessage('Nastavení', 'Nastavení domácnosti uloženo.');
        $this->System->Modules['Log']->NewRecord('Member+Subject', 'Nastavení člena/subjektu změněno', $UserOptions->Values['Name']);
        $DbResult = $this->Database->query('SELECT Member.Id, Member.InternetTariffNextMonth, Member.FamilyMemberCount, Member.BillingPeriodNext, Subject.Name, Subject.AddressStreet, Subject.AddressTown, Subject.AddressPSC, Subject.IC, Subject.DIC FROM Member JOIN Subject ON Subject.Id = Member.Subject WHERE Member.Id='.$this->System->Modules['User']->User['Member']);
        $DbRow = $DbResult->fetch_array();
        foreach($UserOptions->Definition['Items'] as $Index => $Item)
        {
          $UserOptions->Values[$Index] = $DbRow[$Index];
        }
        $UserOptions->OnSubmit = '?Action=MemberOptionsSave';
        $Output .= $UserOptions->ShowEditForm();
      } else
      if($_GET['Action'] == 'ServerAdd')
      {
        $Form = new Form('NewServer');
        $Form->LoadValuesFromForm();
        $Form->OnSubmit = '?Action=ServerCreate';
        $Output .= $Form->ShowEditForm();
      } else
      if($_GET['Action'] == 'ServerCreate')
      {
        $UserOptions = new Form('NewServer', array());
        $UserOptions->LoadValuesFromForm();
        $Output .= $this->SystemMessage('Nový server', 'Server vytvořen.');
        //$UserOptions->LoadValuesFromDatabase($this->System->Modules['User']->User['Id']);
        $UserOptions->OnSubmit = '?Action=ServerCreate';
        $Output .= $UserOptions->ShowEditForm();
      } else
      if($_GET['Action'] == 'ServerShow')
      {
        $DbResult = $this->Database->query('SELECT Id FROM Server WHERE User='.$this->System->Modules['User']->User['Id']);
        $Server = $DbResult->fetch_assoc();
        $Output .= $this->ShowServer($Server['Id']);
      } else
      if($_GET['Action'] == 'ServerEdit')
      {
        $Form = new Form('EditServer');
        $Form->LoadValuesFromForm();
        $Form->OnSubmit = '?Action=ServerSave';
        $Output .= $Form->ShowEditForm();
      } else
      if($_GET['Action'] == 'ServerSave')
      {
        $UserOptions = new Form('EditServer', array());
        $UserOptions->LoadValuesFromForm();
        $Output .= $this->SystemMessage('Upravit server', 'Nastavení serveru uloženo.');
        $UserOptions->LoadValuesFromDatabase($this->System->Modules['User']->User['Id']);
        $UserOptions->OnSubmit = '?Action=ServerSave';
        
        $DbResult = $this->Database->query('SELECT Id FROM Server WHERE User='.$this->System->Modules['User']->User['Id']);
        $Server = $DbResult->fetch_assoc();
        $Server = new Server($this->Database, $Server['Id']);
        $Server->SetupConfigurationFiles();

        $Output .= $UserOptions->ShowEditForm();
      } else
      if($_GET['Action'] == 'ServerStart')
      {
        $DbResult = $this->Database->query('SELECT Id FROM Server WHERE User='.$this->System->Modules['User']->User['Id']);
        $Server = $DbResult->fetch_assoc();
        $Server = new Server($this->Database, $Server['Id']);
        $Output .= $this->SystemMessage('Spuštění serveru', $Server->Start());
      } else
      if($_GET['Action'] == 'ServerStop')
      {
        $DbResult = $this->Database->query('SELECT Id FROM Server WHERE User='.$this->System->Modules['User']->User['Id']);
        $Server = $DbResult->fetch_assoc();
        $Server = new Server($this->Database, $Server['Id']);
        $Output .= $this->SystemMessage('Zastavení serveru', $Server->Stop());
      } else
      if($_GET['Action'] == 'Test')
      {
        //$Server = new Server($this->Database, 1);
        //$Output .= $Server->ImportDatabase();
        $Config = new MangosConfigurationFile($this->Database);
        $Config->Load('../emu/mangos/7681/etc/mangosd.conf');
        $Config->Save('../server/1/etc/mangosd.conf');
      } else
      {
        $Output = $this->ShowServerList();
        $Output .= '<br /><a href="?Action=ServerAdd">Nový server</a>';      
      }
    } else 
    {
      $Output = $this->ShowServerList();
      $Output .= '<br /><a href="?Action=ServerAdd">Nový server</a>';      
    }
    return($Output);
  }
}

$System->AddModule(new Index());
$System->Modules['Index']->GetOutput();

?>
