<?php

class Server extends Module
{
  var $Id;
  var $Server;
  var $WorlddBaseNetworkPort = 8085;
  var $RealmdBaseNetworkPort = 3724;
  
  function __construct($Database, $Id)
  {
    $this->Database = $Database;
    $this->Id = $Id;
    $DbResult = $this->Database->query('SELECT * FROM `Server` WHERE `Id`='.$Id);
    $this->Server = $DbResult->fetch_assoc();
    $DbResult = $this->Database->query('SELECT * FROM `Database` WHERE `Id`='.$this->Server['Database']);
    $this->Server['Database'] = $DbResult->fetch_assoc();
    $DbResult = $this->Database->query('SELECT * FROM `Emulator` WHERE `Id`='.$this->Server['Database']['Emulator']);
    $this->Server['Database']['Emulator'] = $DbResult->fetch_assoc();
    $DbResult = $this->Database->query('SELECT * FROM `ClientVersion` WHERE `Id`='.$this->Server['Database']['Emulator']['ClientVersion']);
    $this->Server['Database']['Emulator']['ClientVersion'] = $DbResult->fetch_assoc();
  }
  
  function AddTask($Title, $Task)
  {
    $this->Database->insert('Task', array('Server' => $this->Server['Id'], 'Title' => $Title, 'Time' => 'NOW()', 'CommandList' => implode("\n", $Task)));
  }
  
  function ImportDatabase()
  {
    $DbResult = $this->Database->query('SELECT * FROM `Database` WHERE `Id`='.$this->Server['Database']);
    $Database = $DbResult->fetch_assoc();
    $DbResult = $this->Database->query('SELECT `Revision` FROM `Emulator` WHERE `Id`='.$Database['Emulator']);
    $Emulator = $DbResult->fetch_assoc();
    $this->AddTask('Inicializace databáze', array(
      'mysql --user=server'.$this->Id.' --password=server'.$this->Id.' server'.$this->Id.'_mangos < emu/mangos/'.$Emulator['Revision'].'/udb/'.$Database['SourceFileName'],
      'mysql --user=server'.$this->Id.' --password=server'.$this->Id.' server'.$this->Id.'_scriptdev2 < emu/mangos/'.$Emulator['Revision'].'/source/src/bindings/ScriptDev2/sql/scriptdev2_create_structure.sql',
      'mysql --user=server'.$this->Id.' --password=server'.$this->Id.' server'.$this->Id.'_scriptdev2 < emu/mangos/'.$Emulator['Revision'].'/source/src/bindings/ScriptDev2/sql/scriptdev2_script_full.sql',
      'mysql --user=server'.$this->Id.' --password=server'.$this->Id.' server'.$this->Id.'_mangos < emu/mangos/'.$Emulator['Revision'].'/source/src/bindings/ScriptDev2/sql/mangos_scriptname_full.sql',
      'mysql --user=server'.$this->Id.' --password=server'.$this->Id.' server'.$this->Id.'_realmd < emu/mangos/'.$Emulator['Revision'].'/mangos/sql/realmd.sql',
      'mysql --user=server'.$this->Id.' --password=server'.$this->Id.' server'.$this->Id.'_characters < emu/mangos/'.$Emulator['Revision'].'/mangos/sql/characters.sql'));
  }
  
  function AddServer($Version)
  {
    
  }
  
  function Start()
  {
    $this->AddTask('Start emulátoru', array(
      'screen -A -m -d -S server'.$this->Id.'-realmd "emu/mangos/'.$this->Server['Database']['Emulator']['Revision'].'/bin/mangos-realmd -c server/'.$this->Id.'/etc/realmd.conf"',
      'screen -A -m -d -S server'.$this->Id.'-worldd emu/mangos/'.$this->Server['Database']['Emulator']['Revision'].'/bin/mangos-worldd -c server/'.$this->Id.'/etc/mangosd.conf',
    ));
    return('Požadavek na start serveru zařazen.');
  }
  
  function Stop()
  {
    $this->AddTask('Zastavení emulátoru', array(
      'ps -ef | grep \'SCREEN -A -m -d -S server'.$this->Id.'-realmd\' | grep -v grep | awk \'{print $2}\' | xargs -i kill {}',
      'ps -ef | grep \'SCREEN -A -m -d -S server'.$this->Id.'-worldd\' | grep -v grep | awk \'{print $2}\' | xargs -i kill {}',
    ));
    return('Požadavek na zastavení serveru zařazen.');
  }
  
  function NetworkPortState($Address, $Port, $Timeout = 1)
  {
    if($Socket = @fsockopen($Address, $Port, $ERROR_NO, $ERROR_STR, (float)$Timeout))
    {
      fclose($Socket);
      return(true);
    } else return(false);
  }
  
  function GetState()
  {
    $State = array();
    $State['RealmdPortState'] = $this->NetworkPortState('localhost', $this->RealmdBaseNetworkPort + $this->Server['Id']);
    $State['WorlddPortState'] = $this->NetworkPortState('localhost', $this->WorlddBaseNetworkPort + $this->Server['Id']);
    return($State);
  }
  
  function SetupConfigurationFiles()
  {
    // mangosd.conf
    $Config = new MangosConfigurationFile($this->Database);
    $Config->Load('../emu/mangos/'.$this->Server['Database']['Emulator']['Revision'].'/etc/mangosd.conf');
    $Config->ParameterList['LoginDatabaseInfo'] = 'localhost;3306;server'.$this->Id.';server'.$this->Id.';server'.$this->Id.'_realmd';
    $Config->ParameterList['WorldDatabaseInfo'] = 'localhost;3306;server'.$this->Id.';server'.$this->Id.';server'.$this->Id.'_mangos';
    $Config->ParameterList['CharacterDatabaseInfo'] = 'localhost;3306;server'.$this->Id.';server'.$this->Id.';server'.$this->Id.'_characters';
    $Config->ParameterList['ScriptDev2DatabaseInfo'] = 'localhost;3306;server'.$this->Id.';server'.$this->Id.';server'.$this->Id.'_scriptdev2';
    $Config->ParameterList['WorldServerPort'] = $this->WorlddBaseNetworkPort + $this->Id;
    $Config->ParameterList['Motd'] = $this->Server['Motd'];
    $Config->ParameterList['DataDir'] = 'wowclient/'.$this->Server['Database']['Emulator']['ClientVersion']['Version'];
    $Config->Save('../server/'.$this->Id.'/etc/mangosd.conf');
   
    // realmd.conf
    $Config = new MangosConfigurationFile($this->Database);
    $Config->Load('../emu/mangos/'.$this->Server['Database']['Emulator']['Revision'].'/etc/realmd.conf');
    $Config->ParameterList['LoginDatabaseInfo'] = 'localhost;3306;server'.$this->Id.';server'.$this->Id.';server'.$this->Id.'_realmd';
    $Config->ParameterList['RealmServerPort'] = $this->RealmdBaseNetworkPort + $this->Id;
    $Config->Save('../server/'.$this->Id.'/etc/realmd.conf');
   
    // scriptdev2.conf
    $Config = new MangosConfigurationFile($this->Database);
    $Config->Load('../emu/mangos/'.$this->Server['Database']['Emulator']['Revision'].'/etc/scriptdev2.conf');
    $Config->ParameterList['ScriptDev2DatabaseInfo'] = 'localhost;3306;server'.$this->Id.';server'.$this->Id.';server'.$this->Id.'_scriptdev2';
    $Config->Save('../server/'.$this->Id.'/etc/scriptdev2.conf');  
  }
}

?>
